//+------------------------------------------------------------------+
//|                                                     Momentum.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Black
#property indicator_color2 Green


//#roperty indicator_level2 20
//property indicator_level3 -20

// #roperty indicator_level4 0.25
//#property indicator_minimum -100
//#property indicator_maximum 100

//---- input parameters
extern string FileName="ion.txt";
extern string Ticker="";

//---- buffers

double IONBuffer_V[];
double IONBuffer_OI[];
//double PriceBuffer[];
string OI_TICKER;
string OI_DATE[4000];
int OI_CALL[4000];
int OI_PUT[4000];
int OI_VOLFUT[4000];
int OI_VOLCALL[4000];
int OI_VOLPUT[4000];
int OI_EOS[4000];
int xlen;
int xbar;
bool shown=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM, EMPTY, 2, Green);
   SetIndexBuffer(0,IONBuffer_V);
   SetIndexStyle(1,DRAW_LINE, EMPTY, 2, Black);
   SetIndexBuffer(1,IONBuffer_OI);
   //SetIndexStyle(1,DRAW_LINE);
//   SetIndexBuffer(1,PriceBuffer);
   
//---- name for DataWindow and indicator subwindow label
   short_name="ION V&OI futures("+FileName+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
//   SetIndexDrawBegin(0,MomPeriod);

//----

int handle;
  int x;
  string str, date1;
  int i; 
  x=0;
  handle=FileOpen(FileName, FILE_CSV|FILE_READ,';');
  if(handle<1)
    {
     Print(" "+FileName+"  ,   ", GetLastError());
     return(false);
    }
    str=FileReadString(handle);
    str=FileReadString(handle);
    str=FileReadString(handle);
    str=FileReadString(handle);
    str=FileReadString(handle);
    str=FileReadString(handle);
    str=FileReadString(handle);
    str=FileReadString(handle);

    while (!FileIsEnding(handle))
    {
      OI_TICKER=FileReadString(handle);
      //Ticker=StringSubstr(Symbol(),0,2);
      if (OI_TICKER == Ticker)
      {
        
        OI_VOLFUT[x]=StrToInteger(FileReadString(handle));
        OI_VOLCALL[x]=StrToInteger(FileReadString(handle));
        OI_VOLPUT[x]=StrToInteger(FileReadString(handle));
        OI_EOS[x]=StrToInteger(FileReadString(handle));
        OI_CALL[x]=StrToInteger(FileReadString(handle)); 
        OI_PUT[x]=StrToInteger(FileReadString(handle));
        OI_DATE[x]=FileReadString(handle);
        //str=FileReadString(handle);
        //Print (OI_TICKER+" "+OI_VOL[x]+" "+OI_PUT[x]+" "+OI_DATE[x]);
        x++;
      } else
      {
        str=FileReadString(handle);
        str=FileReadString(handle);
        str=FileReadString(handle);
        str=FileReadString(handle);
        str=FileReadString(handle);      
        str=FileReadString(handle);
        str=FileReadString(handle);      

      }
      
      
    } 
    xlen=x;
    FileClose(handle);

   
  
   i=0; //Bars-1;
   double r=0.0,q=0.0;
   int f=0;
   while(i<Bars)
     {
       x=0; 
       Print (TimeToStr(Time[i],TIME_DATE));
       while ((OI_DATE[x]!=TimeToStr(Time[i],TIME_DATE)) && x<xlen) { x++; }
       
       if (OI_DATE[x]==TimeToStr(Time[i],TIME_DATE)) { 
         if ((OI_CALL[x]+OI_PUT[x])>0) {
                
                r=OI_VOLFUT[x];
                q=OI_EOS[x];
                if(f==0)
                {
                  f=i;
                  while(f>=0){IONBuffer_V[f]=r;IONBuffer_OI[f]=q;f--;}
                  f=1;
                }
                
              //Print (OI_DATE[x] + " " + OI_CALL[x]+" " +OI_PUT[x]);
              //Print ((TimeToStr(Time[i],TIME_DATE)==OI_DATE[x]) + " " +OI_DATE[x]);
              
              }} else 
              {
                
              }
              IONBuffer_V[i]=r;
              IONBuffer_OI[i]=q;
      i++;
     }
     xbar = Bars;
   return(0);
  }
//+------------------------------------------------------------------+

int start()
  {
    if (!shown) init();
    if (Bars>xbar) init();
    shown=true;
        
  }